Subject: bug#25444: 'guix system init' on GuixSD w/ RAID target produces "guix system: error: failed to register"

From: myglc2 <[email-masked]>
Date: Sat, 14 Jan 2017 12:26:54 -0500

On 01/14/2017 at 14:44 Ludovic Courtès writes:

> Hi,
>
> myglc2 <[email-masked]> skribis:
>
>>     root@g1 ~# guix system init system/g1.00.scm /mnt/md0
>>     [...]
>>     initializing operating system under '/mnt/md0'...
>>     copying '/gnu/store/0m0clxj69xrxb76kyh3ral8lkfb0vx8c-linux-libre-4.9.2'...
>>     In execvp of /usr/local/sbin/guix-register: No such file or directory
>
> The crux of the problem is this last line.  It looks like the Guix
> installation is broken here.
>
> Could you check what happened to this ‘guix-register’ command?

Thanks. I did a fresh guix pull and looked for guix-register. I couldn't
find it my PATH or in guix-latest. But I did find it in the globally
installed guix package.

Then, just to be sure things hadn't magically fixed themselves, I reproduced
the crime ;-)

HTH - George

LOOKING FOR guix-register

root@g1 ~# guix pull

Starting download of /tmp/guix-file.wg2stp
>From http://git.savannah.gnu.org/cgit/guix.git/snapshot/master.tar.gz...
 ….tar.gz                                   2.1MiB/s 00:05 | 10.8MiB transferred
unpacking '/gnu/store/j6c3hhijcn5q5yqydvz35y681ch5q7gb-guix-latest.tar.gz'...
substitute: updating list of substitutes from 'https://mirror.hydra.gnu.org'... 100.0%
The following derivation will be built:
   /gnu/store/nkay6hkzh2lz766v1fr3gcmjp0d0qkyj-guix-latest.drv
building path(s) `/gnu/store/7xl24l9hl73lyr35ff31wprjlfhylm7g-guix-latest'
copying and compiling to '/gnu/store/7xl24l9hl73lyr35ff31wprjlfhylm7g-guix-latest'...
loading...	 24.0% of 567 filesrandom seed for tests: 1484413770
loading...	 99.8% of 567 files
compiling...	 98.8% of 567 files
updated GNU Guix successfully deployed under `/root/.config/guix/latest'

root@g1 ~# find . -name "guix-register"

root@g1 ~# stat ~/.config/guix/latest | grep File:
  File: '/root/.config/guix/latest' -> '/gnu/store/7xl24l9hl73lyr35ff31wprjlfhylm7g-guix-latest'

root@g1 ~# find /gnu/store/7xl24l9hl73lyr35ff31wprjlfhylm7g-guix-latest -name "guix-register"

root@g1 ~# echo $PATH
/home/g1/bin:/home/g1/bin:/root/.guix-profile/bin:/run/setuid-programs:/run/current-system/profile/bin:/run/current-system/profile/sbin

root@g1 ~# guix package -I

root@g1 ~# guix package --list-installed --profile=/run/current-system/profile | grep guix
emacs-guix	0.2.2	out	/gnu/store/bqyhm280m61xwsbcy70jzmadwz19zgvb-emacs-guix-0.2.2
guix	0.12.0-2.b291	out	/gnu/store/53vamzdlzadg9x5zfpandzka87bsmkfh-guix-0.12.0-2.b291

root@g1 ~# find . /gnu/store/53vamzdlzadg9x5zfpandzka87bsmkfh-guix-0.12.0-2.b291 -name "guix-register"
/gnu/store/53vamzdlzadg9x5zfpandzka87bsmkfh-guix-0.12.0-2.b291/sbin/guix-register

REPRODUCING THE CRIME:

root@g1 ~# lsblk -f
NAME    FSTYPE            LABEL    UUID                                 MOUNTPOINT
sdb                                                                     
├─sdb2                                                                  
├─sdb5  linux_raid_member g1:1     644cee85-566f-abce-84c5-5e6f9983c6f8 
│ └─md1 swap                       448fd258-7d0e-45c3-b374-2a2f3be911e0 [SWAP]
├─sdb1  linux_raid_member g1:0     59340f87-fc27-638b-f1cd-42a9a6bdfad3 
│ └─md0 ext4              g1-root  415ba95b-7375-4f26-822c-d3d3e7a0f734 /mnt/md0
└─sdb6  linux_raid_member g1:2     1b0c8ab8-0dad-e743-e5c6-577fcd6419cd 
  └─md2 ext4              g1-bstg  02d1d054-fc65-4773-9597-890b56482b6a /mnt/md2
sdc                                                                     
├─sdc2                                                                  
├─sdc5  linux_raid_member g1:1     644cee85-566f-abce-84c5-5e6f9983c6f8 
│ └─md1 swap                       448fd258-7d0e-45c3-b374-2a2f3be911e0 [SWAP]
├─sdc1  linux_raid_member g1:0     59340f87-fc27-638b-f1cd-42a9a6bdfad3 
│ └─md0 ext4              g1-root  415ba95b-7375-4f26-822c-d3d3e7a0f734 /mnt/md0
└─sdc6  linux_raid_member g1:2     1b0c8ab8-0dad-e743-e5c6-577fcd6419cd 
  └─md2 ext4              g1-bstg  02d1d054-fc65-4773-9597-890b56482b6a /mnt/md2
sda                                                                     
└─sda1  ext4              ssd-root ec3af1c3-2489-4400-acee-a57438b353d4 /

root@g1 ~# guix system init system/g1.00.scm /mnt/md0
guix system: error: failed to load 'system/g1.00.scm': No such file or directory
root@g1 ~# guix system init raid/bugs/25444/g1.00.scm /mnt/md0
/gnu/store/5p908dbxhy58qkrd972pvqyaxjm6yqx2-system
/gnu/store/0gsyrihzxi8zjx2vvkmhwhx9ypp2hdf0-grub.cfg
/gnu/store/b5sqah8g55sms20r98ladyiamwb0s1hy-grub-2.02beta3

initializing operating system under '/mnt/md0'...
copying '/gnu/store/1k2swlkbpf44d5fzgvrp5znafhw90xh7-grub-image.png'...
In execvp of /usr/local/sbin/guix-register: No such file or directory
guix system: error: failed to register '/gnu/store/1k2swlkbpf44d5fzgvrp5znafhw90xh7-grub-image.png' under '/mnt/md0'
root@g1 ~#